/*
Viral Loops v1

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package vloopapi

import (
	"encoding/json"
	"time"
)

// checks if the CompletedMilestone type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CompletedMilestone{}

// CompletedMilestone Finished viral loop milestone for specific referral
type CompletedMilestone struct {
	Id string `json:"id"`
	ReferralId string `json:"referral_id"`
	MilestoneId string `json:"milestone_id"`
	CreatedAt time.Time `json:"created_at"`
	UpdatedAt time.Time `json:"updated_at"`
}

// NewCompletedMilestone instantiates a new CompletedMilestone object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCompletedMilestone(id string, referralId string, milestoneId string, createdAt time.Time, updatedAt time.Time) *CompletedMilestone {
	this := CompletedMilestone{}
	this.Id = id
	this.ReferralId = referralId
	this.MilestoneId = milestoneId
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	return &this
}

// NewCompletedMilestoneWithDefaults instantiates a new CompletedMilestone object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCompletedMilestoneWithDefaults() *CompletedMilestone {
	this := CompletedMilestone{}
	return &this
}

// GetId returns the Id field value
func (o *CompletedMilestone) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *CompletedMilestone) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *CompletedMilestone) SetId(v string) {
	o.Id = v
}

// GetReferralId returns the ReferralId field value
func (o *CompletedMilestone) GetReferralId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ReferralId
}

// GetReferralIdOk returns a tuple with the ReferralId field value
// and a boolean to check if the value has been set.
func (o *CompletedMilestone) GetReferralIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ReferralId, true
}

// SetReferralId sets field value
func (o *CompletedMilestone) SetReferralId(v string) {
	o.ReferralId = v
}

// GetMilestoneId returns the MilestoneId field value
func (o *CompletedMilestone) GetMilestoneId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.MilestoneId
}

// GetMilestoneIdOk returns a tuple with the MilestoneId field value
// and a boolean to check if the value has been set.
func (o *CompletedMilestone) GetMilestoneIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MilestoneId, true
}

// SetMilestoneId sets field value
func (o *CompletedMilestone) SetMilestoneId(v string) {
	o.MilestoneId = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *CompletedMilestone) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *CompletedMilestone) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *CompletedMilestone) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *CompletedMilestone) GetUpdatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *CompletedMilestone) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *CompletedMilestone) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = v
}

func (o CompletedMilestone) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CompletedMilestone) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["referral_id"] = o.ReferralId
	toSerialize["milestone_id"] = o.MilestoneId
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	return toSerialize, nil
}

type NullableCompletedMilestone struct {
	value *CompletedMilestone
	isSet bool
}

func (v NullableCompletedMilestone) Get() *CompletedMilestone {
	return v.value
}

func (v *NullableCompletedMilestone) Set(val *CompletedMilestone) {
	v.value = val
	v.isSet = true
}

func (v NullableCompletedMilestone) IsSet() bool {
	return v.isSet
}

func (v *NullableCompletedMilestone) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCompletedMilestone(val *CompletedMilestone) *NullableCompletedMilestone {
	return &NullableCompletedMilestone{value: val, isSet: true}
}

func (v NullableCompletedMilestone) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCompletedMilestone) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


